cordova.define("cordova-plugin-ucclio.UCClioPlugin", function(require, exports, module) {

               var argscheck = require('cordova/argscheck'),
               utils = require('cordova/utils'),
               exec = require('cordova/exec');

               var mediaObjects = {};

var UCClioPlugin = function (successCallback,recorderEndCallback, errorCallback, statusCallback) {
    this.id = utils.createUUID();
    mediaObjects[this.id] = this;
    this.successCallback = successCallback;
    this.recorderEndCallback = recorderEndCallback;
    this.errorCallback = errorCallback;
    this.statusCallback = statusCallback;
     exec(null, this.errorCallback, "UCClioPlugin", "create", [this.id]);
}

// channel messages
UCClioPlugin.RECORD_STATE = 1;

UCClioPlugin.prototype.start = function (text, rank, type) {
    exec(this.successCallback, this.errorCallback, "UCClioPlugin", "start", [text,rank,type]);
}

UCClioPlugin.prototype.stop = function () {
    exec(this.recorderEndCallback, this.errorCallback, "UCClioPlugin", "stop", null);
}

UCClioPlugin.prototype.cancel = function () {
    exec(null, this.errorCallback, "UCClioPlugin", "cancel", null);
}


UCClioPlugin.onStatus = function(id, msgType, value) {

    var media = mediaObjects[id];

    if (media) {
        switch(msgType) {
            case UCClioPlugin.RECORD_STATE :
                if (media.statusCallback) {
                    media.statusCallback(value);
                }
                break;
            default :
                if (console.error) {
                    console.error("Unhandled UCClioPlugin.onStatus :: " + msgType);
                }
                break;
        }
    } else if (console.error) {
        console.error("Received UCClioPlugin.onStatus callback for unknown media :: " + id);
    }

};


module.exports = UCClioPlugin;

function onMessageFromNative(msg) {
    if (msg.action == 'status') {
        UCClioPlugin.onStatus(msg.status.id, msg.status.msgType, msg.status.value);
    } else {
        throw new Error('Unknown media action' + msg.action);
    }
}

if (cordova.platformId === 'android' || cordova.platformId === 'amazon-fireos' || cordova.platformId === 'windowsphone') {

    var channel = require('cordova/channel');

    channel.createSticky('onUCClioPluginReady');
    channel.waitForInitialization('onUCClioPluginReady');

    channel.onCordovaReady.subscribe(function() {
        exec(onMessageFromNative, undefined, 'UCClioPlugin', 'messageChannel', []);
        channel.initializationComplete('onUCClioPluginReady');
    });
}


});
